#include <stdio.h>
#include <vector>
#include <hip/hip_runtime_api.h>
#include <hipcub/hipcub.hpp>

typedef hipcub::DoubleBuffer<int> Buffer;

void buffer_size(int size, Buffer& keys, Buffer& vals, size_t *buffer_size);

int main(int argc, char* argv[])
{
    int size = 4652275;

    int* d_data = NULL;
    hipMalloc((void**)&d_data, sizeof(int) * size);
    hipMemset(d_data, 0, sizeof(int) * size);

    int* d_perm = NULL;
    hipMalloc((void**)&d_perm, sizeof(int) * size);
    hipMemset(d_perm, 0, sizeof(int) * size);

    int* d_work1 = NULL;
    hipMalloc((void**)&d_work1, sizeof(int) * size);

    int* d_work2 = NULL;
    hipMalloc((void**)&d_work2, sizeof(int) * size);

    Buffer keys(d_data, d_work1);
    Buffer vals(d_perm, d_work2);

    size_t bsize = 0;
    buffer_size(size, keys, vals, &bsize);

    printf("buffersize = %lu\n", bsize);

    hipcub::DeviceRadixSort::SortPairs(nullptr, bsize, keys, vals, size);

    void* buf = NULL;
    hipMalloc(&buf, bsize);

    hipcub::DeviceRadixSort::SortPairs(buf, bsize, keys, vals, size);

    hipFree(buf);
    hipFree(d_data);
    hipFree(d_work1);
    hipFree(d_perm);
    hipFree(d_work2);

    return 0;
}
